
---------------------------
-- create the button
---------------------------
--if you are not setting a value below, do not use it.
Glance.Functions.AddButton("Template","LEFT") --same name from the toc Title, LEFT or RIGHT side of the bar
local btn = Glance.Buttons.Template
btn.text              = "Template"
--btn.font              = "Interface\\Addons\\Glance_Template\\fonts\\"  --use your own font.
--btn.texture.normal    = "Interface\\Addons\\Glance_Template\\images\\" --use your own images
--btn.texture.highlight = "Interface\\Addons\\Glance_Template\\images\\"
btn.enabled           = true -- set to true to run
btn.events            = {"PLAYER_MONEY"} -- comma delimited list of events this button should listen to
btn.update            = true -- use the update function below when your event fires
btn.onload            = true -- if you need to call a function when Glance loads
btn.tooltip           = true -- if you are going to use a tooltip
btn.menu              = true -- if you are going to use a contect menu
btn.click             = true -- if you want your button to handle clicks
--btn.timer1            = true -- 1 second call to update()
--btn.timer5            = true -- 5 second call to update()
--btn.timerTooltip      = true -- 1 second call to tooltip()
--btn.save.perCharacter = {} -- comma delimited list of variables to save per character
--btn.save.perAccount   = {} -- comma delimited list of variables to save per account
--btn.save.allowProfile = false -- true if you want the profile function to copy your per character variables

---------------------------
-- variables
---------------------------
Glance.Variables.x = 1 -- if you need to set a variable

---------------------------
-- timer
---------------------------
-- Glance.Functions.AddTimer("Template",0,5,true,"Template",update,nil) -- if you need to set a timer
-- (timer_name, start_second, end_second, reset_count, button_name, call_function, set_variable )
-- the above timer would call Glance.Functions.Template.update() every 5 seconds

---------------------------
-- update
---------------------------
function Glance.Functions.Template.update()
	local btn = Glance.Buttons.Template -- just easier to type
	if btn.enabled and Glance.Variables.loaded then -- loaded keeps it from launching when defined
		Glance.Debug("function","update","Template") -- debugging routine
		btn.button:SetText("Template!!"..Glance.Variables.x) -- set the button text
		btn.button:SetWidth(btn.button:GetTextWidth()) -- reset the width of the button for the new text
	end
end

---------------------------
-- tooltip
---------------------------
function Glance.Functions.Template.tooltip() -- if you set tooltip to ttrue above, Glance will look for it here.
	Glance.Debug("function","tooltip","Template")
	local btn = Glance.Buttons.Template
	local tooltip = Glance.Functions.Tooltip
	tooltip.Title("Template Tooltip","GLD") -- tooltip title GLD is an RGB value found in variables.lua
	tooltip.Line("This is a line.","WHT") -- single line
	tooltip.Double("How fun is this?","Very!","WHT","GRN") -- double line (column)
	tooltip.Space() -- blank space
	tooltip.Wrap("This is a really, very, incredibly, stupendously, exceptionally long line that wraps.","YEL") -- word wrap
end

---------------------------
-- click
---------------------------
function Glance.Functions.Template.click(self, button, down)
	Glance.Debug("function","click","Template")
	if button == "LeftButton" then -- LeftButton, RightButton, you get the idea
		StaticPopupDialogs["Glance_Clicked"] = {
			text = "You clicked Template!!",
			button1 = TEXT(OKAY),
			timeout = 5,
			hideOnEscape = 1,
			exclusive = 1,
			whileDead = 1
		}
		StaticPopup_Show("Glance_Clicked")
	end
end

---------------------------
-- menu
---------------------------
function Glance.Functions.Template.menu(level,UIDROPDOWNMENU_MENU_VALUE) -- button name as part of the function.  IMPORTANT!
	Glance.Debug("function","menu","Template")
	local HEX = Glance.Arrays.colors.HEX
	level = level or 1
	if (level == 1) then
		--disabled,isTitle,hasArrow,notCheckable,checked,text,value,level,func
		Glance.Functions.setInfo(nil,true,false,true,nil,HEX.white.."Template Options","spacer",level,nil)
		Glance.Functions.setInfo(nil,nil,true,true,nil,HEX.gold.."Display","display",level,nil)
	end
	if (level == 2) then
		if UIDROPDOWNMENU_MENU_VALUE == "display" then
			local checked, func
			checked = true -- just gonna set checked to true here.  
			func = function() Glance.Functions.Template.update() end --some random function
			Glance.Functions.setInfo(nil,false,false,false,checked,"on","on",level,func,nil,true)
			checked = false -- just gonna set checked to false here.  
			func = function() Glance.Functions.Template.update() end --some random function
			Glance.Functions.setInfo(nil,false,false,false,checked,"off","off",level,func,nil,true)
		end
	end
end

---------------------------
-- onload
---------------------------
function Glance.Functions.Template.onload() -- anything you need
	Glance.Debug("function","onload","Template")
	Glance.Variables.x = 2
end


---------------------------
-- load on demand
---------------------------
if Glance.Variables.loaded then
	Glance.Functions.Enable("Template") -- Since these modules are all load on demand, this is needed.
end